#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int period = 8;
extern bool No_repaint = TRUE;
extern int Countbars = 300;
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
string gs_100 = "Leledc-Trend-Hist-Fisher 1.1";

int init() {
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexBuffer(2, g_ibuf_88);
   IndicatorShortName(gs_100 + " (" + period + ")");
   return (0);
}

int start() {
   double ld_0;
   double ld_40;
   double ld_8 = 0;
   double ld_16 = 0;
   double ld_unused_24 = 0;
   double ld_32 = 0;
   double l_low_48 = 0;
   double l_high_56 = 0;
   int li_68 = IndicatorCounted();
   if (li_68 > 0) li_68--;
   int li_64 = Bars - li_68 - 1;
   if (li_64 > Countbars - 1) li_64 = Countbars - 1;
   else li_64 = WindowBarsPerChart();
   ObjectsRedraw();
   
   static string nowBar;  //this line I put in for alert
   
   for (int li_72 = 0; li_72 < li_64; li_72++) {
   
      l_high_56 = High[iHighest(NULL, 0, MODE_HIGH, period, li_72)];
      l_low_48 = Low[iLowest(NULL, 0, MODE_LOW, period, li_72)];
      ld_40 = (High[li_72] + Low[li_72]) / 2.0;
      if (No_repaint == TRUE) {
         if (l_high_56 - l_low_48 == 0.0) ld_16 = ld_8 / 4.0 + (-0.125);
         else ld_16 = ((ld_40 - l_low_48) / (l_high_56 - l_low_48) - 0.5) / 4.0 + ld_8 / 4.0;
         ld_16 = MathMin(MathMax(ld_16, -0.999), 0.999);
         if (1 - ld_16 == 0.0) g_ibuf_88[li_72] = ld_32 / 4.0 + 0.25;
         else g_ibuf_88[li_72] = MathLog((ld_16 + 1.0) / (1 - ld_16)) / 4.0 + ld_32 / 4.0;
         ld_8 = ld_16;
         ld_32 = g_ibuf_88[li_72];
      } else {
         if (No_repaint == FALSE) {
            if (l_high_56 - l_low_48 == 0.0) ld_16 = 0.67 * ld_8 + (-0.33);
            else ld_16 = 0.66 * ((ld_40 - l_low_48) / (l_high_56 - l_low_48) - 0.5) + 0.67 * ld_8;
            ld_16 = MathMin(MathMax(ld_16, -0.999), 0.999);
            if (1 - ld_16 == 0.0) g_ibuf_88[li_72] = 0.75 * ld_32 + 0.25;
            else g_ibuf_88[li_72] = MathLog((ld_16 + 1.0) / (1 - ld_16)) / 4.0 + 0.75 * ld_32;
            ld_8 = ld_16;
            ld_32 = g_ibuf_88[li_72];
         }
      }
   }
   for (li_72 = li_64; li_72 >= 0; li_72--) {
      ld_0 = g_ibuf_88[li_72];
      ld_8 = g_ibuf_88[li_72 + 1];
      if ((ld_0 > 0.0 && ld_8 < 0.0) || ld_0 > 0.0) {
         g_ibuf_92[li_72] = 1.0;
         g_ibuf_96[li_72] = EMPTY_VALUE;
         //Alert("This is first one");
      } else {
         if ((ld_0 < 0.0 && ld_8 > 0.0) || ld_0 < 0.0) {
            g_ibuf_96[li_72] = 1.0;
            g_ibuf_92[li_72] = EMPTY_VALUE;
            //Alert("This is second one");
         }
      }}
      string curTime = TimeToStr(Time[1]);
      //Alert(nowBar + " nowBar");
      if(g_ibuf_92[0] == 1.0 && curTime!= nowBar){
      Alert(TimeToStr(Time[0]) + " Trend Up on " + Symbol()+ " " + Period()+ " min");
      nowBar = TimeToStr(Time[1]); 
      }
      if(g_ibuf_96[0] == 1.0 && curTime!= nowBar){
      Alert(TimeToStr(Time[0]) + " Trend Down on " + Symbol()+ " " + Period()+ " min");
      nowBar = TimeToStr(Time[1]);     
      }
   return (0);
}